package cpcns.dingZhi.keji.controller;

package .var.folders.cl.9twcgjfx4vsg5zl73c6wxmvm0000gn.T;

import cpcns.base.common.User;
import cpcns.base.common.util.JsonWithJacksonUtils;
import cpcns.base.configuration.AppConfiguration;
import cpcns.base.generic.ResultMessage;
import cpcns.common.service.ICommonService;
import cpcns.dangAnBase.base.controller.DangAnBaseController;
import cpcns.danganmenlei.model.GDangAnMenLei;
import cpcns.danganmenlei.service.IGDangAnMenLeiService;
import cpcns.dingZhi.keji.model.keJi;
import cpcns.dingZhi.keji.service.IKeJiService;
import cpcns.dingZhi.tongYong.service.ItongYongService;
import cpcns.printManager.PrintUtil;
import cpcns.utils.CommStatic;
import cpcns.utils.PagerVO;
import cpcns.utils.tool;
import java.util.ArrayList;
import java.util.HashMap;
import java.util.List;
import java.util.Map;
import javax.servlet.http.HttpServletRequest;
import javax.servlet.http.HttpServletResponse;
import org.apache.commons.lang.StringUtils;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Controller;
import org.springframework.ui.Model;
import org.springframework.web.bind.annotation.RequestMapping;

@Controller
@RequestMapping({"keJiController"})
public class KeJiController extends DangAnBaseController {
  @Autowired
  private IKeJiService keJiService;
  
  @Autowired
  private IGDangAnMenLeiService gDangAnMenLeiService;
  
  @Autowired
  private ItongYongService tongYongService;
  
  @Autowired
  private ICommonService<?> commonService;
  
  @RequestMapping({"/toList.do"})
  public String toList(HttpServletRequest request, Model model) {
    String zhuangTai = getRequest().getParameter("zhuangTai");
    getRequest().setAttribute("zhuangTai", zhuangTai);
    return "dingZhi/keji/keJi_list";
  }
  
  @RequestMapping({"/toAdd.do"})
  public String toAdd(HttpServletRequest request, Model model) {
    keJi obj = new keJi();
    User user = getCurrentUser();
    obj.setQuanZongHao(user.getQuanZongHao());
    model.addAttribute("kejiwenjian", obj);
    String menLei = request.getParameter("menLei");
    obj.setMenLei(menLei);
    obj.setZhuangTai(Integer.valueOf(2));
    GDangAnMenLei dam = this.gDangAnMenLeiService.getByFenLeiHao(menLei);
    if (dam != null) {
      model.addAttribute("dangHaoGuiZe", dam.getDangHaoGuiZe());
      model.addAttribute("fenGeFu", dam.getFenGeFu());
      model.addAttribute("xuHaoGuiZe", dam.getZiFuDaiMa());
      model.addAttribute("qiDongDangHao", dam.getQiDongDangHao());
    } 
    obj.setFenShu("1");
    getRequest().setAttribute("taa", Integer.valueOf(0));
    model.addAttribute("keji", obj);
    return "dingZhi/keji/keJi_edit";
  }
  
  @RequestMapping({"/query.do"})
  public String query(HttpServletRequest request, HttpServletResponse response, Model model) {
    try {
      Map<String, Object> map = tool.getRequestParamsMaps(request);
      pageBase(model);
      PagerVO pagevo = this.keJiService.query_SQL(this.start, this.number, this.table, map, CommStatic.getOrderBy(request, "dangHao"));
      String jsonString = JsonWithJacksonUtils.getInstance().obj2Json(pagevo).replaceAll(" 00:00:00", "").replaceAll(":00", "")
        .replaceAll("", "").replaceAll("HANGBIAOSHI", "hangBiaoShi").replaceAll("QUANZONGHAO", "quanZongHao")
        .replaceAll("WENJIANBIANHAO", "wenJianBianHao").replaceAll("MIJI", "miJi").replaceAll("BIAOTI", "biaoTi")
        .replaceAll("CHENGWENRIQI", "chengWenRiQi").replaceAll("DANGHAO", "dangHao").replaceAll("ZERENZHE", "zeRenZhe").replaceAll("WENJIANKAISHISHIJIAN", "wenJianKaiShiShiJian")
        .replaceAll("BAOGUANQIXIAN", "baoGuanQiXian").replaceAll("GUIDANGNIANDU", "guiDangNianDu");
      write(response, jsonString);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return null;
  }
  
  @RequestMapping({"/saveOrUpdate.do"})
  public void save(HttpServletRequest request, HttpServletResponse response, keJi obj) {
    ResultMessage rm = new ResultMessage();
    String info = "";
    try {
      if (obj != null) {
        Map<String, String> map1 = new HashMap<>();
        map1.put("table", this.table);
        map1.put("server", this.server);
        map1.put("guiDangNianDu", obj.getGuiDangNianDu());
        map1.put("quanZongHaoString", obj.getQuanZongHao());
        map1.put("baoGuanQiXian", obj.getBaoGuanQiXian());
        map1.put("biaoTiString", obj.getBiaoTi());
        map1.put("zhuangTai_notin", "3,4");
        if (obj.getHangBiaoShi() != null && obj.getHangBiaoShi().intValue() > 0)
          map1.put("hangBiaoShi_not", String.valueOf(obj.getHangBiaoShi())); 
        String rizhi = "";
        if (!this.keJiService.IsExist(map1)) {
          if (obj.getHangBiaoShi() != null && obj.getHangBiaoShi().intValue() > 0) {
            rizhi = "修改";
            this.keJiService.update(obj);
          } else {
            rizhi = "新增";
            obj.setHangBiaoShi(Integer.valueOf(this.keJiService.getPk(this.table)));
            obj.setZhuangTai(Integer.valueOf(2));
            if (obj.getGuanLianBiaoShi() == null || "".equals(obj.getGuanLianBiaoShi())) {
              obj.setGuanLianBiaoShi("0");
            } else {
              obj.setGuanLianBiaoShi(obj.getGuanLianBiaoShi());
            } 
            this.keJiService.save(obj);
          } 
          rm.setSuccess(true);
          info = "保存成功！";
          rm.addResultMessage("hangBiaoShi", obj.getHangBiaoShi());
          this.keJiService.addDA_RiZhi(getCurrentUser(), this.server, this.table, obj.getHangBiaoShi(), String.valueOf(obj.getBiaoTi()) + "$." + obj.getDangHao() + "$." + obj.getMenLei(), rizhi);
        } else {
          rm.setSuccess(false);
          info = "题名已存在";
        } 
      } else {
        rm.setSuccess(false);
        info = "数据转换错误！";
      } 
    } catch (Exception e) {
      e.printStackTrace();
      rm.setSuccess(false);
      info = "操作失败！";
    } 
    rm.setInfo(info);
    responseWriter(response, rm.toString());
  }
  
  @RequestMapping({"/open.do"})
  public String open(HttpServletRequest request, HttpServletResponse response, Model model) {
    try {
      String quanXian = request.getParameter("quanXian");
      String check = request.getParameter("check");
      String taa = getRequest().getParameter("taa");
      if ("1".equals(check))
        quanXian = "false"; 
      model.addAttribute("quanXian", quanXian);
      String cxzt = request.getParameter("cxzt");
      model.addAttribute("cxzt", cxzt);
      Integer hangBiaoShi = Integer.valueOf(Integer.parseInt(request.getParameter("hangBiaoShi")));
      String ids = request.getParameter("keyWordResult");
      model.addAttribute("keyWordResult", ids);
      keJi obj = (keJi)this.keJiService.getById(keJi.class, hangBiaoShi);
      if (StringUtils.isNotBlank(obj.getMenLei())) {
        GDangAnMenLei dam = this.gDangAnMenLeiService.getByFenLeiHao(obj.getMenLei());
        if (dam != null) {
          model.addAttribute("dangHaoGuiZe", dam.getDangHaoGuiZe());
          model.addAttribute("fenGeFu", dam.getFenGeFu());
          model.addAttribute("xuHaoGuiZe", dam.getZiFuDaiMa());
          model.addAttribute("qiDongDangHao", dam.getQiDongDangHao());
        } 
      } 
      getRequest().setAttribute("taa", taa);
      model.addAttribute("keji", obj);
      this.keJiService.addDA_RiZhi(getCurrentUser(), this.server, this.table, hangBiaoShi, String.valueOf(obj.getBiaoTi()) + "$." + obj.getDangHao() + "$." + obj.getMenLei(), "查看");
      Integer fenshu = this.tongYongService.queryIsNotFile(hangBiaoShi, this.table);
      if (fenshu.intValue() > 0) {
        String AJname = this.tongYongService.queryAjName(hangBiaoShi, this.table);
        model.addAttribute("AJname", AJname);
      } 
      model.addAttribute("fenshu", fenshu);
    } catch (Exception e) {
      e.printStackTrace();
    } 
    return "dingZhi/keji/keJi_edit";
  }
  
  @RequestMapping({"/delete.do"})
  public void delete(HttpServletRequest request, HttpServletResponse response) {
    ResultMessage rm = new ResultMessage();
    String info = "";
    try {
      String hangBiaoShi = request.getParameter("hangBiaoShi");
      String biaoTi = request.getParameter("biaoTi");
      String dangHao = request.getParameter("dangHao");
      if (StringUtils.isNotBlank(hangBiaoShi)) {
        User user = getCurrentUser();
        rm.setSuccess(true);
        keJi kj = (keJi)this.keJiService.getById(keJi.class, Integer.valueOf(Integer.parseInt(hangBiaoShi)));
        info = "删除成功！";
        this.commonService.deleteByUser(getCurrentUser(), this.server, getTable(), hangBiaoShi);
        this.keJiService.addDA_RiZhi(user, this.server, this.table, Integer.valueOf(Integer.parseInt(hangBiaoShi)), String.valueOf(biaoTi) + "$." + dangHao + "$." + kj.getMenLei(), "删除");
      } else {
        rm.setSuccess(false);
        info = "获取参数失败，无法删除，请联系管理员！";
      } 
    } catch (Exception e) {
      e.printStackTrace();
      rm.setSuccess(false);
      info = "删除失败！";
    } 
    rm.setInfo(info);
    responseWriter(response, rm.toString());
  }
  
  @RequestMapping({"/Print.do"})
  public String damlPrint(HttpServletRequest request, HttpServletResponse response, Model model) throws Exception {
    User user = getCurrentUser();
    String printService = AppConfiguration.getConfigValue("printServlet");
    String menLei = request.getParameter("menLei");
    String moban = "danganmulu_" + menLei + ".jasper";
    Map<String, Object> map = tool.getRequestParamsMaps(request);
    HashMap<String, Object> params = new HashMap<>();
    pageBase(model);
    List<Map<String, Object>> list = this.keJiService.getDate(this.table, map, user);
    List<Map<String, Object>> listAll = new ArrayList<>();
    for (Map<String, Object> m : list) {
      String cw = "";
      String wj = "";
      for (Map.Entry<String, Object> entry : m.entrySet()) {
        String key = entry.getKey();
        String value = (String)entry.getValue();
        if ("WENJIANKAISHISHIJIAN".equals(key) && StringUtils.isNotBlank(value)) {
          entry.setValue(value.replaceAll("-", "."));
          wj = entry.getValue().split(" ")[0];
        } 
        if ("CHENGWENRIQI".equals(key) && StringUtils.isNotBlank(value))
          if (StringUtils.isNotBlank(wj) && !"null".equals(wj)) {
            entry.setValue(String.valueOf(wj) + "-" + value.replaceAll("-", ".").split(" ")[0]);
          } else {
            entry.setValue(value.replaceAll("-", ".").split(" ")[0]);
          }  
        if ("MIJI".equals(key) && "2".equals(value))
          entry.setValue("秘密"); 
        if ("MIJI".equals(key) && "3".equals(value))
          entry.setValue("机密"); 
        if ("MIJI".equals(key) && "4".equals(value))
          entry.setValue("绝密"); 
        if ("BAOGUANQIXIAN".equals(key) && "D30".equals(value))
          entry.setValue("定期30年"); 
        if ("BAOGUANQIXIAN".equals(key) && "Y".equals(value))
          entry.setValue("永久"); 
        if ("BAOGUANQIXIAN".equals(key) && "D10".equals(value))
          entry.setValue("定期10年"); 
        if ("BAOGUANQIXIAN".equals(key) && "CY".equals(value))
          entry.setValue("长久"); 
        if ("BAOGUANQIXIAN".equals(key) && "DQ".equals(value))
          entry.setValue("定期"); 
        if ("BAOGUANQIXIAN".equals(key) && "CQ".equals(value))
          entry.setValue("长期"); 
        if ("BAOGUANQIXIAN".equals(key) && "dq".equals(value))
          entry.setValue("短期"); 
        if ("BAOGUANQIXIAN".equals(key) && "D15".equals(value))
          entry.setValue("定期15年"); 
        if ("BAOGUANQIXIAN".equals(key) && "D25".equals(value))
          entry.setValue("定期25年"); 
      } 
      listAll.add(m);
    } 
    PrintUtil.printService(request, user, printService, moban, listAll, params, "zyda");
    return "print/check";
  }
}
